package org.opengroup.osdu.register.provider.azure.subscriber;

import com.microsoft.azure.CloudException;
import com.microsoft.azure.arm.model.Indexable;
import com.microsoft.azure.management.eventgrid.v2020_04_01_preview.WebHookEventSubscriptionDestination;
import com.microsoft.azure.management.eventgrid.v2020_04_01_preview.implementation.EventGridManager;
import org.opengroup.osdu.core.common.logging.JaxRsDpsLog;
import org.opengroup.osdu.core.common.model.http.AppException;
import org.opengroup.osdu.register.provider.azure.di.AzureBootstrapConfig;
import org.opengroup.osdu.register.utils.AppServiceConfig;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.concurrent.atomic.AtomicReference;

@Component
public class PushSubscription {

    private static final String RESOURCE_PROVISIONING_ERROR_MESSAGE = "Resource cannot be updated during provisioning";
    /*@Autowired
    private EventGridManager eventGridManager;*/

    @Autowired
    private AzureBootstrapConfig azureBootstrapConfig;

    @Autowired
    private JaxRsDpsLog logger;

    @Autowired
    private AppServiceConfig serviceConfig;

    public void createPushSubscription(String subscriptionId, String topicName) {
        WebHookEventSubscriptionDestination subscriptionDestination = new WebHookEventSubscriptionDestination();
        subscriptionDestination.withEndpointUrl(serviceConfig.getRecordsChangePubsubEndpoint());
        subscriptionDestination.withAzureActiveDirectoryTenantId(azureBootstrapConfig.getAzureTenantId());
        subscriptionDestination.withAzureActiveDirectoryApplicationIdOrUri(azureBootstrapConfig.getAzureAppResourceId());

        String scope = String.format("/subscriptions/%s/resourceGroups/%s/providers/Microsoft.EventGrid/topics/%s", azureBootstrapConfig.getAzureSubscriptionId(), azureBootstrapConfig.getResourceGroupName(), topicName);
        AtomicReference<Throwable> error = new AtomicReference<>();

        /*eventGridManager.eventSubscriptions().define(subscriptionId)
                .withScope(scope)
                .withDestination(subscriptionDestination)
                .createAsync()
                .toBlocking()
                .subscribe(
                        (Indexable indexable) -> {},
                        error::set,
                        () -> logger.info(String.format("Push Subscription with id %s created successfully", subscriptionId))
                );

        if(error.get() != null) {
            if(error.get().getMessage().equals(RESOURCE_PROVISIONING_ERROR_MESSAGE)) {
                logger.error("Another request is trying to create the same Push subscription");
                throw new AppException(409, "Conflict", "Another request is trying to create the same Push subscription");
            }
            else {
                logger.error("Creating Push Subscription failed with error: " + error.get().toString());
                throw new AppException(500, "Server Error", "Unexpected error creating Push subscription");
            }
        }*/

    }

    public void deletePushSubscription(String subscriptionId, String topicName) {
        String scope = String.format("/subscriptions/%s/resourceGroups/%s/providers/Microsoft.EventGrid/topics/%s", azureBootstrapConfig.getAzureSubscriptionId(), azureBootstrapConfig.getResourceGroupName(), topicName);
        AtomicReference<Throwable> error = new AtomicReference<>();
       /* eventGridManager.eventSubscriptions().deleteAsync(scope, subscriptionId)
                .subscribe(() -> logger.info(String.format("Push Subscription with id %s deleted successfully", subscriptionId)), error::set);

        if(error.get() != null) {
            if(error.get() instanceof CloudException) {
                CloudException cloudException = (CloudException) error.get();
                logger.error(cloudException.toString());
                throw new AppException(cloudException.response().code(), cloudException.body().code(), cloudException.body().message());
            }
            else {
                logger.error("Deleting Push Subscription failed with error: " + error.get().toString());
                throw new AppException(500, "Server Error", "Unexpected error deleting Push subscription");
            }
        }*/
    }

    public void checkIfPushSubscriptionExists(String subscriptionId, String topicName) {
        String scope = String.format("/subscriptions/%s/resourceGroups/%s/providers/Microsoft.EventGrid/topics/%s", azureBootstrapConfig.getAzureSubscriptionId(), azureBootstrapConfig.getResourceGroupName(), topicName);
        AtomicReference<Throwable> error = new AtomicReference<>();
        /*eventGridManager.eventSubscriptions().getAsync(scope, subscriptionId)
                .subscribe(
                        (Indexable indexable) -> {},
                        error::set,
                        () -> logger.info(String.format("Push Subscription with id %s fetched successfully", subscriptionId))
                );

        if(error.get() != null) {
            if(error.get() instanceof NullPointerException) {
                logger.error(String.format("Push Subscription with id %s does not exist.", subscriptionId));
                throw new AppException(404, "Not found", String.format("Push Subscription with id %s does not exist.", subscriptionId));
            }
            else {
                logger.error("Fetching Push subscription failed with error: " + error.get().toString());
                throw new AppException(500, "Server Error", "Unexpected error while Fetching Push subscription");
            }
        }*/
    }

}
