package org.opengroup.osdu.register.provider.gcp.logging;

import org.opengroup.osdu.core.common.logging.ILogger;
import org.opengroup.osdu.core.gcp.logging.logger.appengine.AppEngineLoggingProvider;

import org.springframework.beans.factory.FactoryBean;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.context.annotation.Lazy;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Component;

@Component
@ConditionalOnProperty(name="enable.appengine.log.factory", havingValue = "true")
@Primary
@Lazy
public class AppengineLogFactory implements FactoryBean<ILogger> {

    private AppEngineLoggingProvider appEngineLoggingProvider = new AppEngineLoggingProvider();

    @Override
    public ILogger getObject() throws Exception {
        return appEngineLoggingProvider.getLogger();
    }

    @Override
    public Class<?> getObjectType() {
        return ILogger.class;
    }
}
