package org.opengroup.osdu.register.util;

import com.google.common.base.Strings;
import org.apache.commons.lang.NullArgumentException;

public class GCPTestUtils extends TestUtils {

    @Override
    public synchronized String getOpsAccessToken() throws Exception {
        if (Strings.isNullOrEmpty(opsToken)) {
            opsToken = getToken("DE_OPS_TESTER");
        }
        return "Bearer " + opsToken;
    }

    @Override
    public synchronized String getAdmAccessToken() throws Exception {
        if (Strings.isNullOrEmpty(admToken)) {
            admToken = getToken("DE_ADMIN_TESTER");
        }
        return "Bearer " + admToken;
    }

    @Override
    public synchronized String getEditorAccessToken() throws Exception {
        if (Strings.isNullOrEmpty(editorToken)) {
            editorToken = getToken("DE_EDITOR_TESTER");
        }
        return "Bearer " + editorToken;
    }

    @Override
    public synchronized String getNoDataAccessToken() throws Exception {
        if (Strings.isNullOrEmpty(noAccessToken)) {
            noAccessToken = getToken("DE_NO_ACCESS_TESTER");
        }
        return "Bearer " + noAccessToken;
    }

    private String getToken(String testerEnvVar) throws Exception {
        String serviceAccountFile = System.getProperty(testerEnvVar, System.getenv(testerEnvVar));
        String audience = System.getProperty("INTEGRATION_TEST_AUDIENCE", System.getenv("INTEGRATION_TEST_AUDIENCE"));
        if (Strings.isNullOrEmpty(audience)) {
            audience = "245464679631-ktfdfpl147m1mjpbutl00b3cmffissgq.apps.googleusercontent.com";
        }
        return new GoogleServiceAccount(serviceAccountFile).getAuthToken(audience);

    }
}
